aboutsummaryrefslogtreecommitdiff
path: root/gen
diff options
context:
space:
mode:
authorThomas Voss <mail@thomasvoss.com> 2024-04-16 23:35:34 +0200
committerThomas Voss <mail@thomasvoss.com> 2024-04-16 23:35:34 +0200
commit6912c5d4544aa25a5aeb74549abcb32870b9b18a (patch)
treebeff7a0d0fb44a71ccba2f9094d6ba84cff3e022 /gen
parent5180ce98cfd8f6d235a71e555712d62044572871 (diff)
Add uprop_get_gcb()
Diffstat (limited to 'gen')
-rwxr-xr-xgen/prop/gcb83
1 files changed, 83 insertions, 0 deletions
diff --git a/gen/prop/gcb b/gen/prop/gcb
new file mode 100755
index 0000000..17d3136
--- /dev/null
+++ b/gen/prop/gcb
@@ -0,0 +1,83 @@
+#!/bin/sh
+
+set -e
+cd "${0%/*}/../.."
+exec >lib/unicode/prop/uprop_get_gcb.c
+
+gawk '
+BEGIN {
+ FS = "( *#.*| *; +)"
+
+ map["Control"] = "CN"
+ map["CR"] = "CR"
+ map["E_Base"] = "EB"
+ map["E_Base_GAZ"] = "EBG"
+ map["E_Modifier"] = "EM"
+ map["Extend"] = "EX"
+ map["Glue_After_Zwj"] = "GAZ"
+ map["LF"] = "LF"
+ map["L"] = "L"
+ map["LV"] = "LV"
+ map["LVT"] = "LVT"
+ map["Other"] = "XX"
+ map["Prepend"] = "PP"
+ map["Regional_Indicator"] = "RI"
+ map["SpacingMark"] = "SM"
+ map["T"] = "T"
+ map["V"] = "V"
+ map["ZWJ"] = "ZWJ"
+
+ print "/* This file is autogenerated by gen/prop/gcb; DO NOT EDIT. */"
+ print ""
+ print "#include \"_bsearch.h\""
+ print "#include \"macros.h\""
+ print "#include \"rune.h\""
+ print "#include \"unicode/prop.h\""
+ print ""
+}
+
+/^[^#]/ {
+ n = split($1, a, /\.\./)
+ lo = strtonum("0X" a[1])
+ hi = strtonum("0X" a[n])
+
+ for (i = lo; i <= hi; i++) {
+ gsub(/^; /, "", $2)
+ props[i] = "GCB_" map[$2]
+ }
+}
+
+END {
+ print "static constexpr enum uprop_gcb lookup_lat1[] = {"
+ for (i = 0; i < 0x100; i++) {
+ if (i % 8 == 0)
+ printf "\t"
+ printf "%-7s%s", (props[i] ? props[i] : "GCB_XX") ",", \
+ i % 8 == 7 ? "\n" : " "
+ }
+ print "};"
+ print ""
+ print "static const struct {"
+ print "\trune lo, hi;"
+ print "\tenum uprop_gcb val;"
+ print "} lookup[] = {"
+
+ for (i = 0x100; i <= 0x10FFFF; i++) {
+ if (!props[i])
+ continue
+ for (lo = i; props[lo] == props[i + 1]; i++)
+ ;
+ printf "\t{RUNE_C(0x%06X), RUNE_C(0x%06X), %s},\n", lo, i, props[i]
+ }
+
+ print "};"
+ print ""
+ print "_MLIB_DEFINE_BSEARCH(enum uprop_gcb, lookup, GCB_XX)"
+ print ""
+ print "enum uprop_gcb"
+ print "uprop_get_gcb(rune ch)"
+ print "{"
+ print "\treturn ch < lengthof(lookup_lat1) ? lookup_lat1[ch] : mlib_lookup(ch);"
+ print "}"
+}
+' data/GraphemeBreakProperty | sed 's/\s*$//'